> ## Documentation Index
> Fetch the complete documentation index at: https://docs.helloannie.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create response

> Send a user message to an existing conversation and receive a response from the bot associated with the conversation. The conversation must be in the OPEN state. CLOSED conversations return 400 Bad Request. CLOSING conversations return 409 Conflict. If the conversation has exceeded its non-resettable open window, a 409 Conflict is returned and auto-close is triggered.



## OpenAPI

````yaml /openapi/openapi.yaml post /conversations/{conversationId}/responses
openapi: 3.0.3
info:
  title: Annie API
  description: >
    ### Overview


    The Annie API is a (mostly) RESTful API. Typically, both POST bodies and
    responses are JSON-encoded.


    Note: The documenation is Work In Progress and is subject to change.


    ### Base URL


    The base URL for the Annie API is https://api.helloannie.com/.


    Examples in this document may abbreviate this to `/`.


    ### Versioning


    Routes are prefixed with a version number i.e. `v1`. The version will change
    when there is a non-backwards compatible or other significant change to the
    api.


    ### Authentication


    The Annie API supports two authentication methods API Keys and OAuth Access
    Tokens:


    #### API Keys


    API Keys are long-lived tokens that can be generated from the Developer
    Portal on your organization page. API keys are prefixed with `annie-sk-v2-`
    and can be used directly in the `Authorization` header.


    ```

    curl -H "Authorization: Bearer annie-sk-xxxxx"
    https://api.helloannie.com/...

    ```


    #### OAuth Tokens


    OAuth tokens are short-lived access tokens generated using the OAuth 2.0
    Client Credentials flow (Machine-to-Machine). OAuth clients provide scoped
    permissions and are ideal for server-to-server integrations.


    **Creating an OAuth Client**


    OAuth clients can be created in the Developer Portal on your organization
    page. When creating a client, you'll receive:


    - `client_id`: Your OAuth client identifier

    - `client_secret`: Your OAuth client secret (store this securely)


    **Generating an OAuth Token**


    To generate an OAuth access token, make a POST request to the Annie OAuth
    token endpoint:


    **Endpoint:** `https://annie-external-api.us.auth0.com/oauth/token`


    **Example Request:**


    ```bash

    curl -X POST https://annie-external-api.us.auth0.com/oauth/token \
      -H "Content-Type: application/json" \
      -d '{
        "grant_type": "client_credentials",
        "client_id": "your-client-id",
        "client_secret": "your-client-secret",
        "audience": "https://api.helloannie.com"
      }'
    ```


    The `access_token` from the response should be used in the `Authorization`
    header when making requests to the Annie API:


    ```

    curl -H "Authorization: Bearer eyJhbGciOiJSUzI..."
    https://api.helloannie.com/v1/...

    ```


    ### API Response Structure


    The Annie API returns status codes consistent with standard HTTP
    conventions. Success and Error responses follow the below structure:


    ```

    {
      "success": boolean
      "data": {}
      "message": string // optional
    }

    ```


    ### Rate Limiting


    The Annie API enforces rate limits to ensure stability and fair usage. The
    default rate limit is **60 requests per minute** per organization. This
    limit is applied per endpoint pattern (e.g. `GET /v1/bots/:id`).


    When the rate limit is exceeded, the API responds with HTTP `429 Too Many
    Requests`.


    Response headers include:


    - `X-RateLimit-Limit`: The maximum number of requests allowed in the current
    window.

    - `X-RateLimit-Remaining`: The number of requests remaining in the current
    window.

    - `X-RateLimit-Reset`: The time at which the current rate limit window
    resets (in UTC epoch seconds).


    If you exceed the limit, the response will contain a `Retry-After` header
    indicating how many seconds to wait before retrying.


    ### Pagination


    The Annie API does not currently support pagination. All results are
    returned at once.
  version: v1
servers:
  - url: https://api.helloannie.com/v1
security: []
paths:
  /conversations/{conversationId}/responses:
    post:
      tags:
        - Responses
      summary: Create response
      description: >-
        Send a user message to an existing conversation and receive a response
        from the bot associated with the conversation. The conversation must be
        in the OPEN state. CLOSED conversations return 400 Bad Request. CLOSING
        conversations return 409 Conflict. If the conversation has exceeded its
        non-resettable open window, a 409 Conflict is returned and auto-close is
        triggered.
      operationId: postV1ConversationsByConversationIdResponses
      parameters:
        - name: conversationId
          in: path
          required: true
          schema:
            format: uuid
            description: The ID of the conversation to create a response for
            type: string
      requestBody:
        description: Request body for creating a response on an OPEN conversation
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ResponseRequest'
          application/x-www-form-urlencoded:
            schema:
              $ref: '#/components/schemas/ResponseRequest'
          multipart/form-data:
            schema:
              $ref: '#/components/schemas/ResponseRequest'
      responses:
        '200':
          description: >-
            Response returned after creating an assistant response on an OPEN
            conversation
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Response'
        '400':
          description: The request was invalid or malformed
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadRequestResponse'
        '403':
          description: You do not have permission to perform this action
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ForbiddenResponse'
        '404':
          description: The requested resource was not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFoundResponse'
        '409':
          description: The request conflicts with another in-progress operation
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ConflictResponse'
components:
  schemas:
    ResponseRequest:
      additionalProperties: false
      type: object
      required:
        - message
      properties:
        message:
          description: The user message to send to the conversation
          minLength: 1
          type: string
    Response:
      additionalProperties: false
      type: object
      required:
        - success
        - data
      properties:
        success:
          enum:
            - true
          type: boolean
        data:
          additionalProperties: false
          description: The response data
          type: object
          required:
            - message
            - messageId
            - createdAt
          properties:
            message:
              description: The agent generated response message
              type: string
            toolCalls:
              description: List of tool calls that were executed during the response
              type: array
              items:
                additionalProperties: false
                description: Result of a tool call execution
                type: object
                required:
                  - toolName
                  - success
                properties:
                  toolName:
                    description: The name of the tool that was called
                    type: string
                  success:
                    description: Whether the tool call was successful
                    type: boolean
            messageId:
              format: uuid
              description: The ID of the saved assistant message
              type: string
            createdAt:
              type: string
              format: date-time
    BadRequestResponse:
      additionalProperties: false
      type: object
      required:
        - success
        - data
        - message
      properties:
        success:
          enum:
            - false
          type: boolean
        data:
          additionalProperties: false
          type: object
          properties: {}
        message:
          type: string
    ForbiddenResponse:
      additionalProperties: false
      type: object
      required:
        - success
        - data
        - message
      properties:
        success:
          enum:
            - false
          type: boolean
        data:
          additionalProperties: false
          type: object
          properties: {}
        message:
          type: string
    NotFoundResponse:
      additionalProperties: false
      type: object
      required:
        - success
        - data
        - message
      properties:
        success:
          enum:
            - false
          type: boolean
        data:
          additionalProperties: false
          type: object
          properties: {}
        message:
          type: string
    ConflictResponse:
      additionalProperties: false
      type: object
      required:
        - success
        - data
        - message
      properties:
        success:
          enum:
            - false
          type: boolean
        data:
          additionalProperties: false
          type: object
          properties: {}
        message:
          type: string

````